//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ZylSerialPort"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnOpenClick(TObject *Sender)
{
  if (cmbPort->ItemIndex < 0)
  {
	ShowMessage("Select a port!");
	return;
  }
  if (lstBaudRate->ItemIndex < 0)
  {
	ShowMessage("Select a baud rate!");
	return;
  }

  ZylSerialPort1->Port = (TCommPort)(cmbPort->ItemIndex + 1);
  ApplySettings();
  //AnsiString str = AnsiChar(0);
  ZylSerialPort1->NewLine = "\n"; //newline CrLf
  ZylSerialPort1->Open();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZylSerialPort1Receive(TObject *Sender, AnsiString Buffer)
{
  //TStringList* endChars = new TStringList();
  Buffer = ZylSerialPort1->ReadStringUpToEndChars(ZylSerialPort1->NewLine);
  //endChars->Free();
  if (rgMode->ItemIndex == 0)
  {
	if (!cbShowHiddenChars->Checked)
	{
		Memo->Lines->Add(Buffer);
	}
	else
	{
		Memo->Lines->Add(ZylSerialPort1->ReplaceControlChars(Buffer));
	}
  }
  else if (rgMode->ItemIndex == 1)
  {
	AnsiString strBuffer = "";
    for (int i = 1; i <= Buffer.Length(); i++)
      strBuffer += IntToStr(int(Buffer[i]));
	Memo->Lines->Add(strBuffer);
  }
  else
  {
    AnsiString strBuffer = "";
    for (int i = 1; i <= Buffer.Length(); i++)
      strBuffer += IntToHex(int(Buffer[i]), 1);
    Memo->Lines->Add(strBuffer);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSendStrClick(TObject *Sender)
{
  ZylSerialPort1->SendString(efText->Text);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  lstBaudRate->ItemIndex = lstBaudRate->Items->IndexOf("4800");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZylSerialPort1Connect(TObject *Sender, TCommPort Port)
{
  Memo->Lines->Add("Connected to:" + ZylSerialPort1->CommPortToString(Port));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ZylSerialPort1Disconnect(TObject *Sender, TCommPort Port)
{
  Memo->Lines->Add("Disconnected from:" + ZylSerialPort1->CommPortToString(Port));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnCloseClick(TObject *Sender)
{
  ZylSerialPort1->Close();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::btnApplyClick(TObject *Sender)
{
   ApplySettings();
}
//---------------------------------------------------------------------------

void TForm1::ApplySettings()
{
  ZylSerialPort1->BaudRate = ZylSerialPort1->IntToBaudRate(
	StrToInt(lstBaudRate->Items->Strings[lstBaudRate->ItemIndex]));
  ZylSerialPort1->DataWidth = (TDataWidth)(rbDataWidth->ItemIndex);
  ZylSerialPort1->Parity = (TParityBits)(rbParity->ItemIndex);
  ZylSerialPort1->StopBits = (TStopBits)(rbStopBits->ItemIndex);
  if (cbDTR->Checked)
  {
	ZylSerialPort1->EnableDTROnOpen = true;
  }
  else
  {
	ZylSerialPort1->EnableDTROnOpen = false;
  }

  if (cbRTS->Checked)
  {
	ZylSerialPort1->EnableRTSOnOpen = true;
  }
  else
  {
	ZylSerialPort1->EnableRTSOnOpen = false;
  }
   ZylSerialPort1->HwFlowControl = (THwFlowControl)(rbHwFlowControl->ItemIndex);
   ZylSerialPort1->SwFlowControl = (TSwFlowControl)(rbSwFlowControl->ItemIndex);
}
